import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class DmoPolices
   extends JFrame implements ItemListener
{
   private JComboBox m_NomsPolices;
   private JLabel
      m_Famille,
      m_FamilleGras,
      m_FamilleItalique,
      m_FamilleGrasItalique;
   private JButton m_Bouton;
   private Font [] m_Polices;
   private JComboBox m_Tailles;

   public DmoPolices ()
   {
      super ("Dmonstrateur de polices de caractres");
   }

   private String [] ChargerNomsPolices ()
   {
      GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment ();
      m_Polices = ge.getAllFonts ();
      String [] NomsPolices = null;
      if (m_Polices != null)
      {
         NomsPolices = new String [m_Polices.length];
         for (int i = 0; i < NomsPolices.length; i++)
            NomsPolices[i] = m_Polices[i].getFontName ();
      }
      return NomsPolices;
   }

   private String [] CrerListeTailles ()
   {
      final int NB_TAILLES_SUPPORTES = 50,
                TAILLE_BASE = 8;
      String [] Tailles = new String [NB_TAILLES_SUPPORTES];
      for (int i = 0; i < Tailles.length; i++)
         Tailles[i] = "" + (TAILLE_BASE + i * 2);
      return Tailles;
   }

   public void init ()
   {
      //
      // Obtenir la liste de toutes les polices de caractres
      // disponibles sur la plate-forme locale
      //
      m_NomsPolices = new JComboBox (ChargerNomsPolices ());
      m_NomsPolices.addItemListener (this);

      //
      // Construire un liste de tailles de polices pour que
      // l'usager puisse y piger
      //
      m_Tailles = new JComboBox (CrerListeTailles ());
      m_Tailles.addItemListener (this);

      //
      // Crer des tiquettes de dmonstration pour la police
      // et la taille choisies
      //
      m_Famille = new JLabel ("Famille");
      m_FamilleGras = new JLabel ("Famille gras");
      m_FamilleItalique = new JLabel ("Famille italique");
      m_FamilleGrasItalique = new JLabel ("Famille gras italique");

      //
      // Disposition: deux listes droulantes  gauche
      //
      JPanel PanneauSlecteurs = new JPanel ();
      PanneauSlecteurs.setLayout (new GridLayout (2,1));
      PanneauSlecteurs.add (m_NomsPolices);
      PanneauSlecteurs.add (m_Tailles);
      getContentPane ().add (PanneauSlecteurs, BorderLayout.WEST);

      //
      // Disposition: quatre polices  droite
      //
      JPanel PanneauDmo = new JPanel ();
      PanneauDmo.setLayout (new GridLayout (4, 1));
      PanneauDmo.add (m_Famille);
      PanneauDmo.add (m_FamilleGras);
      PanneauDmo.add (m_FamilleItalique);
      PanneauDmo.add (m_FamilleGrasItalique);
      getContentPane ().add (PanneauDmo, BorderLayout.EAST);

      //
      // Mise  jour avant un premier affichage
      //
      MettreJourFamilles ();
   }

   //
   // Mettre  jour le contenu des tiquettes de dmonstration
   // en fonction des slections dans les listes droulantes
   //
   public void MettreJourFamilles ()
   {
      final int Index = m_NomsPolices.getSelectedIndex ();
      final int Taille = Integer.parseInt ((String) m_Tailles.getSelectedItem ());
      final String Nom = m_Polices[Index].getFontName ();
      final String NomFamille = m_Polices[Index].getFamily ();
      m_Famille.setText (NomFamille);
      m_Famille.setFont (new Font (Nom, Font.PLAIN, Taille));
      m_FamilleGras.setText (NomFamille + " (gras)");
      m_FamilleGras.setFont (new Font (Nom, Font.BOLD, Taille));
      m_FamilleItalique.setText (NomFamille + " (italique)");
      m_FamilleItalique.setFont (new Font (Nom, Font.ITALIC, Taille));
      m_FamilleGrasItalique.setText (NomFamille + " (gras italique)");
      m_FamilleGrasItalique.setFont (new Font (Nom, Font.BOLD | Font.ITALIC, Taille));
      pack ();
   }

   public void itemStateChanged (ItemEvent ie)
   {
      MettreJourFamilles ();
   }

   public static void main (String [] args)
   {
      DmoPolices dp = new DmoPolices ();
      dp.init ();
      dp.pack ();
      dp.show ();
      dp.addWindowListener
      (
         new WindowAdapter ()
         {
            public void windowClosing (WindowEvent we)
            {
               System.exit (0);
            }
         }
      );
   }
}