import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*; // ListSelectionListener, ListSelectionEvent, etc.

public class ExplorateurApparence
   extends JFrame implements ListSelectionListener
{
   private static final String
      TITRE_DFAUT = "Explorateur d'apparences";

   private String [] m_NomsApparences;
   private UIManager.LookAndFeelInfo [] m_Aspects;
   private JList m_ListeAspects;

   private void ChargerApparences ()
   {
      m_Aspects = UIManager.getInstalledLookAndFeels ();
      if (m_Aspects.length > 0)
      {
         m_NomsApparences = new String [m_Aspects.length];
         for (int i = 0; i < m_NomsApparences.length; i++)
            m_NomsApparences[i] = new String (m_Aspects[i].getClassName ());
      }
      else
         m_NomsApparences = null;
   }

   public ExplorateurApparence ()
   {
      this (TITRE_DFAUT);
   }

   public ExplorateurApparence (final String Titre)
   {
      super (Titre);
      ChargerApparences ();
   }


   public void init ()
   {
      final String TEXTE_DESCRIPTIF = "Apparence choisie";

      JPanel PanneauEntte = new JPanel ();
      PanneauEntte.setLayout (new FlowLayout ());
      PanneauEntte.add (new JLabel (TEXTE_DESCRIPTIF));

      if (m_NomsApparences != null)
      {
         m_ListeAspects = new JList (m_NomsApparences);
         m_ListeAspects.setSelectionMode (ListSelectionModel.SINGLE_INTERVAL_SELECTION);
         m_ListeAspects.setVisibleRowCount (m_NomsApparences.length);
         m_ListeAspects.setSelectedIndex (0);
      }
      else
      {
         String [] temp =  { "None" };
         m_ListeAspects = new JList (temp);
         m_ListeAspects.setSelectionMode (ListSelectionModel.SINGLE_INTERVAL_SELECTION);
         m_ListeAspects.setEnabled (false);
      }

      m_ListeAspects.addListSelectionListener (this);
      PanneauEntte.add (new JScrollPane (m_ListeAspects));

      getContentPane ().add (PanneauEntte, BorderLayout.NORTH);


      // -- StuffPanel
      final String [] LISTE_EXEMPLE = { "lment 0", "lment 1", "lment 2" };
      JPanel PanneauCossins = new JPanel ();
      PanneauCossins.setLayout (new GridLayout (2, 3));

      JRadioButton [] jrb = new JRadioButton [3];
      ButtonGroup jbg = new ButtonGroup ();
      for (int i = 0; i < jrb.length; i++)
      {
         jrb[i] = new JRadioButton ("Exemple de bouton d'option " + i);
         PanneauCossins.add (jrb[i]);
         jbg.add (jrb[i]);
      }

      jrb[0].setSelected (true);

      PanneauCossins.add (new JCheckBox("Exemple de case  cocher"));
      PanneauCossins.add (new JButton ("Exemple de bouton"));
      PanneauCossins.add (new JComboBox (LISTE_EXEMPLE));

      getContentPane ().add (PanneauCossins, BorderLayout.CENTER);
   }

   public void valueChanged (ListSelectionEvent ev)
   {
      int Selection = m_ListeAspects.getSelectedIndex ();
      try
      {
         UIManager.setLookAndFeel (m_Aspects[Selection].getClassName ());
         SwingUtilities.updateComponentTreeUI (this);
      }
      catch (Exception e)
      {
        e.printStackTrace (); // INVESTIGATE
      }
   }


   public static void main (String [] args)
   {
      ExplorateurApparence ea = new ExplorateurApparence ();
      ea.init ();
      ea.pack ();
      ea.addWindowListener
      (
         new WindowAdapter ()
         {
            public void windowClosing (WindowEvent e)
            {
               System.exit (0);
            }
         }
      );
      ea.show ();
   }
}


