import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class PanneauListe
                      extends JPanel
                      implements ListSelectionListener
{
   private JList m_Liste;
   private DefaultListModel m_Liste_Contenu;
   private boolean m_MultiSelection;

   public JList GetListe ()
   {
      return m_Liste;
   }

   public Object [] GetValeursSelectionnees ()
   {
      if (!m_Liste.isSelectionEmpty())
         return m_Liste.getSelectedValues ();
      return null;
   }

   public boolean AucuneSelection ()
   {
      return m_Liste.isSelectionEmpty();
   }

   public void ViderListe ()
   {
      if (m_Liste_Contenu.size () > 0)
      {
         m_Liste.setSelectedIndex (0); // forcer vnement de liste
         m_Liste_Contenu.removeRange (0, m_Liste_Contenu.size ()-1);
      }
   }

   private void RemplirListe (DefaultListModel dest, String [] src)
   {
      if (src != null && dest != null)
         for (int i = 0; i < src.length; i++)
            dest.addElement (src[i]);
   }

   public void RafrachirListe (String []src)
   {
      ViderListe ();
      RemplirListe (m_Liste_Contenu, src);
   }

   public void valueChanged (ListSelectionEvent lse)
   {
      if (lse.getValueIsAdjusting()) return; // VALIDER
   }

   public void init ()
   {
      setLayout (new BorderLayout ());
      final int NB_LIGNES_MONO = 1,
                NB_COLONNES_MONO = 1;
      JPanel PanneauMonolithique = new JPanel ();

      m_Liste_Contenu = new DefaultListModel();
      m_Liste = new JList (m_Liste_Contenu);
      if (!m_MultiSelection)
      {
        m_Liste.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      }
      m_Liste.addListSelectionListener (this);
      PanneauMonolithique.setLayout (new GridLayout (NB_LIGNES_MONO, NB_COLONNES_MONO));
      PanneauMonolithique.add (new JScrollPane (m_Liste), BorderLayout.CENTER);

      add (PanneauMonolithique);
   }

   public PanneauListe ()
   {
      this (true);
   }

   public PanneauListe (final boolean MultiSelection)
   {
      super ();
      m_MultiSelection = MultiSelection;
      init ();
   }
}

